Attribute VB_Name = "Module1"
Option Explicit

Public Type POINTAPI
    X As Long
    Y As Long
End Type

Public Type Radiants
    Hour As Single
    Minute As Single
    Second As Single
End Type

Private Type SYSTEMTIME
  wYear As Integer
  wMonth As Integer
  wDayOfWeek As Integer
  wDay As Integer
  wHour As Integer
  wMinute As Integer
  wSecond As Integer
  wMilliseconds As Integer
End Type

Private Declare Sub GetLocalTime Lib "kernel32.dll" (ByRef lpSystemTime As SYSTEMTIME)

Public Center As POINTAPI
 
Public Const PI As Single = 3.1415926

Private Function Modulo(ByVal Quotient As Double, ByVal Divisor As Double) As Double

Modulo = Quotient - Fix(Quotient / Divisor) * Divisor
    
End Function

Public Function RotatePointAroundCenter(Center As POINTAPI, Point As POINTAPI, Angle As Single) As POINTAPI

Dim MyCos As Single
Dim MySin As Single
Dim TempPoint1 As POINTAPI
Dim TempPoint2 As POINTAPI

MyCos = Cos(Angle)
MySin = Sin(Angle)

TempPoint1.X = Center.X + Sqr(((Center.X - Point.X) ^ 2) + ((Center.Y - Point.Y) ^ 2))
TempPoint1.Y = Center.Y 'First, make it horizontal
TempPoint2.X = Center.X + (MyCos * (TempPoint1.X - Center.X))
TempPoint2.Y = Center.Y - (MySin * (TempPoint1.X - Center.X))

RotatePointAroundCenter = TempPoint2

End Function

Public Function GetTimeRadiants() As Radiants

Dim CurrTime As SYSTEMTIME

Dim RadiantInfo As Radiants

Call GetLocalTime(CurrTime)

If CurrTime.wHour > 12 Then CurrTime.wHour = CurrTime.wHour - 12
RadiantInfo.Hour = ((CurrTime.wHour + (CurrTime.wMinute / 60)) / 12) * (2 * PI)
RadiantInfo.Hour = RadiantInfo.Hour / PI * 180
RadiantInfo.Hour = Modulo((450 - RadiantInfo.Hour), 360)
RadiantInfo.Hour = RadiantInfo.Hour / 180 * PI

RadiantInfo.Minute = ((CurrTime.wMinute + (CurrTime.wSecond / 60)) / 60) * (2 * PI)
RadiantInfo.Minute = RadiantInfo.Minute / PI * 180
RadiantInfo.Minute = Modulo((450 - RadiantInfo.Minute), 360)
RadiantInfo.Minute = RadiantInfo.Minute / 180 * PI

RadiantInfo.Second = ((CurrTime.wSecond + (CurrTime.wMilliseconds / 1000)) / 60) * (2 * PI)
RadiantInfo.Second = RadiantInfo.Second / PI * 180
RadiantInfo.Second = Modulo((450 - RadiantInfo.Second), 360)
RadiantInfo.Second = RadiantInfo.Second / 180 * PI

GetTimeRadiants = RadiantInfo

End Function
